// Generated by CoffeeScript 1.9.0
(function() {
  var assert, teacup,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  module.exports = function(ko) {
    var RuleTarget, html, view;
    RuleTarget = (function() {
      function RuleTarget(data) {
        assert(data != null, 'data is required');
        this.source_registrant = ko.observable(data.source_registrant);
        this.gwid = ko.observable(data.gwid);
        this.carrierid = ko.observable(data.carrierid);
        this._validated = ko.observable(false);
        return;
      }

      return RuleTarget;

    })();
    view = function(_arg) {
      var $root, carrier_valid, carriers, chosen, gateway_valid, gateways, value;
      value = _arg.value, $root = _arg.$root;
      assert(value instanceof RuleTarget, 'value should be an instance of RuleTarget');
      gateways = $root.gateways, carriers = $root.carriers;
      assert(gateways != null, 'gateways is required');
      assert(carriers != null, 'carriers is required');
      chosen = value.source_registrant() === true ? 'registrant' : value.carrierid() != null ? 'carrier' : value.gwid() != null ? 'gateway' : void 0;
      this.chosen = ko.observable(chosen);
      this.chosen.subscribe((function(_this) {
        return function() {
          return value.source_registrant(_this.chosen() === 'registrant');
        };
      })(this));
      this.gwid = value.gwid;
      this.carrierid = value.carrierid;
      gateway_valid = function(id) {
        return (id != null) && __indexOf.call(gateways, id) >= 0;
      };
      carrier_valid = function(id) {
        return (id != null) && __indexOf.call(carriers, id) >= 0;
      };
      return this.valid = ko.pureComputed((function(_this) {
        return function() {
          var is_valid;
          is_valid = (function() {
            switch (this.chosen()) {
              case 'registrant':
                return true;
              case 'gateway':
                return gateway_valid(this.gwid());
              case 'carrier':
                return carrier_valid(this.carrierid());
              default:
                return false;
            }
          }).call(_this);
          value._validated(is_valid);
          return is_valid;
        };
      })(this));
    };
    html = function() {
      var a, input, label, li, name, text, ul;
      name = "rule-target-" + (Math.random());
      a = teacup.a, ul = teacup.ul, li = teacup.li, label = teacup.label, input = teacup.input, text = teacup.text;
      return ul('.target', function() {
        li('.choice', function() {
          return label(function() {
            input({
              type: 'radio',
              name: name,
              value: 'registrant',
              required: true,
              bind: {
                checked: 'chosen'
              }
            });
            return text('Use Registrant');
          });
        });
        li('.choice', function() {
          label(function() {
            input({
              type: 'radio',
              name: name,
              value: 'carrier',
              bind: {
                checked: 'chosen'
              },
              required: true
            });
            return text('Use Carrier ');
          });
          return input({
            list: 'carrier',
            name: 'carrierid',
            bind: {
              value: 'carrierid',
              enable: 'chosen() === "carrier"'
            },
            required: true
          });
        });
        return li('.choice', function() {
          label(function() {
            input({
              type: 'radio',
              name: name,
              value: 'gateway',
              bind: {
                checked: 'chosen'
              },
              required: true
            });
            return text('Use Gateway ');
          });
          return input({
            list: 'gateway',
            name: 'gwid',
            bind: {
              value: 'gwid',
              enable: 'chosen() === "gateway"'
            },
            required: true
          });
        });
      });
    };
    ko.components.register('rule-target', {
      viewModel: view,
      template: teacup.render(html)
    });
    return RuleTarget;
  };

  teacup = require('teacup');

  teacup.use((require('teacup-databind'))());

  assert = require('assert');

}).call(this);
